#import <objectbase/SwarmObject.h>
#include <misc/avl.h> //for the AVLtree
      
@interface AVLSet: SwarmObject
{
  avl_tree * myTree;
}

+ createBegin: aZone;

+ createBegin:  (int (*)(const void*,const void*,void*)) compareFunc  Param: (void *) param Zone: aZone;

- createEnd;

//Methods for the Set Protocol
-(BOOL) add: anObject;

- (id *) replace: anObject;

//End Set Protocol



//New thing I made up because I didn't like the Swarm's Set default behavior
- forcefulReplace: anObject;

-(void)  walk: (void (*)(void*,void*)) aFunction Param: (void *) PARAM;

- traverse: (avl_traverser *) travPtr;
//KeyedCollection Protocol
- at: aKey;

- removeKey: aKey;

- (BOOL) containsKey: aKey;

- createIndex: (id <Zone>)aZone fromMember: anObject ;

//EndKeyedCollection Protocol

//Methods for Collections protocol
- (int) getCount;

- (void) drop;

- removeAll;

-  deleteAll;

@end


@interface UDiamCluster: SwarmObject
{
  int N;
  id *  population;
  double * * dissMatrix;
  id <List> clusterList;
}


+ create: aZone N: (int) num DissMatr: (double **) diss; 
-init;
- agglomerateClusters: list Threshold: (double) k ;

- clusterK: (double) threshold ;

- elimRedundantClusters: (id <List>) list;

-(void) drop;
- printMembers;


@end








